From 59b5ba1f1433a89865f52e2cbaa231a0f7ad1940 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 10 2020 18:36:08 +0000
Subject: [PATCH 244/2232] Include BaseTsd.h to get SSIZE_T


---

diff --git a/gen/include.rs b/gen/include.rs
index e3a9dd7..8f38fe3 100644
--- a/gen/include.rs
+++ b/gen/include.rs
@@ -38,6 +38,7 @@ pub struct Includes {
     pub string: bool,
     pub type_traits: bool,
     pub utility: bool,
+    pub base_tsd: bool,
 }
 
 impl Includes {
@@ -88,6 +89,11 @@ impl Display for Includes {
         if self.utility {
             writeln!(f, "#include <utility>")?;
         }
+        if self.base_tsd {
+            writeln!(f, "#if defined(_WIN32)")?;
+            writeln!(f, "#include <BaseTsd.h>")?;
+            writeln!(f, "#endif")?;
+        }
         if *self != Self::default() {
             writeln!(f)?;
         }
diff --git a/gen/write.rs b/gen/write.rs
index 9d6ef6e..d80e957 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -126,6 +126,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
                 needs_rust_fn = true;
             }
             ty if ty == Isize => {
+                out.include.base_tsd = true;
                 needs_rust_isize = true;
             }
             ty if ty == RustString => {
diff --git a/include/cxx.h b/include/cxx.h
index 6fe55d0..27034f0 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -7,6 +7,9 @@
 #include <string>
 #include <type_traits>
 #include <utility>
+#if defined(_WIN32)
+#include <BaseTsd.h>
+#endif
 
 namespace rust {
 inline namespace cxxbridge02 {

